<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:11 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>AttributesSchema (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="AttributesSchema (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/attributes/AttributeMatchingStrategy.html" title="interface in org.gradle.api.attributes"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/attributes/CompatibilityCheckDetails.html" title="interface in org.gradle.api.attributes"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/attributes/AttributesSchema.html" target="_top">Frames</a></li>
<li><a href="AttributesSchema.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.api.attributes</div>
<h2 title="Interface AttributesSchema" class="title">Interface AttributesSchema</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
public interface <span class="strong">AttributesSchema</span></pre>
<div class="block">An attributes schema stores information about <a href="../../../../org/gradle/api/attributes/Attribute.html" title="class in org.gradle.api.attributes"><code>attributes</code></a> and how they
 can be matched together.</div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>3.3</dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="../../../../org/gradle/api/attributes/AttributeMatchingStrategy.html" title="interface in org.gradle.api.attributes">AttributeMatchingStrategy</a>&lt;T&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/attributes/AttributesSchema.html#attribute(org.gradle.api.attributes.Attribute)">attribute</a></strong>(<a href="../../../../org/gradle/api/attributes/Attribute.html" title="class in org.gradle.api.attributes">Attribute</a>&lt;T&gt;&nbsp;attribute)</code>
<div class="block">Declares a new attribute in the schema and configures it with the default strategy.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="../../../../org/gradle/api/attributes/AttributeMatchingStrategy.html" title="interface in org.gradle.api.attributes">AttributeMatchingStrategy</a>&lt;T&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/attributes/AttributesSchema.html#attribute(org.gradle.api.attributes.Attribute,%20org.gradle.api.Action)">attribute</a></strong>(<a href="../../../../org/gradle/api/attributes/Attribute.html" title="class in org.gradle.api.attributes">Attribute</a>&lt;T&gt;&nbsp;attribute,
         <a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/attributes/AttributeMatchingStrategy.html" title="interface in org.gradle.api.attributes">AttributeMatchingStrategy</a>&lt;T&gt;&gt;&nbsp;configureAction)</code>
<div class="block">Configures the matching strategy for an attribute.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/7/docs/api/java/util/Set.html?is-external=true" title="class or interface in java.util">Set</a>&lt;<a href="../../../../org/gradle/api/attributes/Attribute.html" title="class in org.gradle.api.attributes">Attribute</a>&lt;?&gt;&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/attributes/AttributesSchema.html#getAttributes()">getAttributes</a></strong>()</code>
<div class="block">Returns the set of attributes known to this schema.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="../../../../org/gradle/api/attributes/AttributeMatchingStrategy.html" title="interface in org.gradle.api.attributes">AttributeMatchingStrategy</a>&lt;T&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/attributes/AttributesSchema.html#getMatchingStrategy(org.gradle.api.attributes.Attribute)">getMatchingStrategy</a></strong>(<a href="../../../../org/gradle/api/attributes/Attribute.html" title="class in org.gradle.api.attributes">Attribute</a>&lt;T&gt;&nbsp;attribute)</code>
<div class="block">Returns the matching strategy for a given attribute.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/attributes/AttributesSchema.html#hasAttribute(org.gradle.api.attributes.Attribute)">hasAttribute</a></strong>(<a href="../../../../org/gradle/api/attributes/Attribute.html" title="class in org.gradle.api.attributes">Attribute</a>&lt;?&gt;&nbsp;key)</code>
<div class="block">Returns true when this schema contains the given attribute.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getMatchingStrategy(org.gradle.api.attributes.Attribute)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMatchingStrategy</h4>
<pre>&lt;T&gt;&nbsp;<a href="../../../../org/gradle/api/attributes/AttributeMatchingStrategy.html" title="interface in org.gradle.api.attributes">AttributeMatchingStrategy</a>&lt;T&gt;&nbsp;getMatchingStrategy(<a href="../../../../org/gradle/api/attributes/Attribute.html" title="class in org.gradle.api.attributes">Attribute</a>&lt;T&gt;&nbsp;attribute)
                                                 throws <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></pre>
<div class="block">Returns the matching strategy for a given attribute.</div>
<dl><dt><span class="strong">Type Parameters:</span></dt><dd><code>T</code> - the type of the attribute</dd><dt><span class="strong">Parameters:</span></dt><dd><code>attribute</code> - the attribute</dd>
<dt><span class="strong">Returns:</span></dt><dd>the matching strategy for this attribute.</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></code> - When no strategy is available for the given attribute.</dd></dl>
</li>
</ul>
<a name="attribute(org.gradle.api.attributes.Attribute)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>attribute</h4>
<pre>&lt;T&gt;&nbsp;<a href="../../../../org/gradle/api/attributes/AttributeMatchingStrategy.html" title="interface in org.gradle.api.attributes">AttributeMatchingStrategy</a>&lt;T&gt;&nbsp;attribute(<a href="../../../../org/gradle/api/attributes/Attribute.html" title="class in org.gradle.api.attributes">Attribute</a>&lt;T&gt;&nbsp;attribute)</pre>
<div class="block">Declares a new attribute in the schema and configures it with the default strategy.
 If the attribute was already declared it will simply return the existing strategy.</div>
<dl><dt><span class="strong">Type Parameters:</span></dt><dd><code>T</code> - the concrete type of the attribute</dd><dt><span class="strong">Parameters:</span></dt><dd><code>attribute</code> - the attribute to declare in the schema</dd>
<dt><span class="strong">Returns:</span></dt><dd>the matching strategy for this attribute</dd></dl>
</li>
</ul>
<a name="attribute(org.gradle.api.attributes.Attribute, org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>attribute</h4>
<pre>&lt;T&gt;&nbsp;<a href="../../../../org/gradle/api/attributes/AttributeMatchingStrategy.html" title="interface in org.gradle.api.attributes">AttributeMatchingStrategy</a>&lt;T&gt;&nbsp;attribute(<a href="../../../../org/gradle/api/attributes/Attribute.html" title="class in org.gradle.api.attributes">Attribute</a>&lt;T&gt;&nbsp;attribute,
                                         <a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/attributes/AttributeMatchingStrategy.html" title="interface in org.gradle.api.attributes">AttributeMatchingStrategy</a>&lt;T&gt;&gt;&nbsp;configureAction)</pre>
<div class="block">Configures the matching strategy for an attribute. The first call to this method for a specific attribute
 will create a new matching strategy, whereas subsequent calls will configure the existing one.</div>
<dl><dt><span class="strong">Type Parameters:</span></dt><dd><code>T</code> - the concrete type of the attribute</dd><dt><span class="strong">Parameters:</span></dt><dd><code>attribute</code> - the attribute for which to configure the matching strategy</dd><dd><code>configureAction</code> - the strategy configuration</dd>
<dt><span class="strong">Returns:</span></dt><dd>the configured strategy</dd></dl>
</li>
</ul>
<a name="getAttributes()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getAttributes</h4>
<pre><a href="https://docs.oracle.com/javase/7/docs/api/java/util/Set.html?is-external=true" title="class or interface in java.util">Set</a>&lt;<a href="../../../../org/gradle/api/attributes/Attribute.html" title="class in org.gradle.api.attributes">Attribute</a>&lt;?&gt;&gt;&nbsp;getAttributes()</pre>
<div class="block">Returns the set of attributes known to this schema.</div>
</li>
</ul>
<a name="hasAttribute(org.gradle.api.attributes.Attribute)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>hasAttribute</h4>
<pre>boolean&nbsp;hasAttribute(<a href="../../../../org/gradle/api/attributes/Attribute.html" title="class in org.gradle.api.attributes">Attribute</a>&lt;?&gt;&nbsp;key)</pre>
<div class="block">Returns true when this schema contains the given attribute.</div>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/attributes/AttributeMatchingStrategy.html" title="interface in org.gradle.api.attributes"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/attributes/CompatibilityCheckDetails.html" title="interface in org.gradle.api.attributes"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/attributes/AttributesSchema.html" target="_top">Frames</a></li>
<li><a href="AttributesSchema.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
